unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, NMSTRM, Psock;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Memo1: TMemo;
    Button1: TButton;
    Memo2: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    NMStrmServ1: TNMStrmServ;
    NMStrm1: TNMStrm;
    procedure Button1Click(Sender: TObject);
    procedure NMStrm1MessageSent(Sender: TObject);
    procedure NMStrmServ1MSG(Sender: TComponent; const sFrom: String;
      strm: TStream);
    procedure NMStrmServ1Connect(Sender: TObject);
    procedure NMStrmServ1ConnectionFailed(Sender: TObject);
    procedure NMStrmServ1Disconnect(Sender: TObject);
    procedure NMStrmServ1HostResolved(Sender: TComponent);
    procedure NMStrmServ1InvalidHost(var Handled: Boolean);
    procedure NMStrmServ1ClientContact(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  MS: TMemoryStream;
  I : Integer;
begin
  NMStrm1.Host := Edit1.Text;
  NMStrm1.FromName := Edit2.Text;
  MS := TMemoryStream.Create;
  try
   for I := 0 to Memo2.Lines.Count -1 do
        StreamLn(MS, Memo2.Lines.Strings[I]);
   NMStrm1.PostIt(MS);
  finally
   MS.Free;
  end; 
end;

procedure TForm1.NMStrm1MessageSent(Sender: TObject);
begin
  Memo1.Lines.Add(' ');
end;

procedure TForm1.NMStrmServ1MSG(Sender: TComponent; const sFrom: String;
  strm: TStream);
var
  SS: TStringStream;
begin
  SS := TStringStream.Create('');
  try
   SS.CopyFrom(strm, strm.size);
   Memo1.Lines.Add(timetostr(time)+'  "'+sFrom+'"  ');
   Memo1.Lines.Add(' -----');
   Memo1.Lines.Add(SS.DataString);
   Memo1.Lines.Add(' ------');
  finally
   SS.Free;
  end;
end;

procedure TForm1.NMStrmServ1Connect(Sender: TObject);
begin
  Memo1.Lines.Add('  '+NMStrm1.Host);
end;

procedure TForm1.NMStrmServ1ConnectionFailed(Sender: TObject);
begin
  ShowMessage('    ');
end;

procedure TForm1.NMStrmServ1Disconnect(Sender: TObject);
begin
  Memo1.Lines.Add(' ');
end;

procedure TForm1.NMStrmServ1HostResolved(Sender: TComponent);
begin
  Memo1.Lines.Add(' ');
end;

procedure TForm1.NMStrmServ1InvalidHost(var Handled: Boolean);
var
  TmpStr: String;
begin
  If InputQuery(' !', '    :', TmpStr) then
  Begin
    NMStrm1.Host := TmpStr;
    Handled := True;
  End;
end;

procedure TForm1.NMStrmServ1ClientContact(Sender: TObject);
begin
  NMStrmServ1.ReportLevel := Status_Basic;
  NMStrmServ1.TimeOut := 30000;
  Memo1.Lines.Add('  ');
end;

end.
